﻿@inject Microsoft.AspNetCore.Http.IHttpContextAccessor HttpContextAccessor;
@{
    string valueDonViChiTIet = HttpContextAccessor.HttpContext.Request.Cookies["DonViChiTIet"];
    string valueBoPhan = HttpContextAccessor.HttpContext.Request.Cookies["BoPhan"];
}
@*<script type="text/javascript" src="https://code.jquery.com/jquery-3.5.1.min.js"></script>*@

<script type="text/javascript" src="https://cdn3.devexpress.com/jslib/21.1.6/js/dx.all.js"></script>
<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/exceljs/4.3.0/exceljs.min.js"></script>
<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/FileSaver.js/2.0.0/FileSaver.min.js"></script>

<script type="text/javascript" src="~/assets/plugins/jquery-datepick/js/jquery.plugin.min.js"></script>
<script type="text/javascript" src="~/assets/plugins/jquery-datepick/js/jquery.datepick.min.js"></script>
<script type="text/javascript" src="~/assets/plugins/jquery-datepick/js/jquery.datepick.ext.js"></script>
<script type="text/javascript" src="~/assets/plugins/jquery-datepick/js/jquery.datepick.validation.js"></script>
<script type="text/javascript" src="~/assets/plugins/jquery-datepick/js/jquery.datepick-vi.js"></script>

<script type="text/javascript">
    


    function createCookie(name, value, days) {
        var expires;

        if (days) {
            var date = new Date();
            date.setTime(date.getTime() + (days * 24 * 60 * 60 * 1000));
            expires = "; expires=" + date.toGMTString();
        } else {
            expires = "";
        }
        document.cookie = encodeURIComponent(name) + "=" + encodeURIComponent(value) + expires + "; path=/";
    }

    function readCookie(name) {
        var nameEQ = encodeURIComponent(name) + "=";
        var ca = document.cookie.split(';');
        for (var i = 0; i < ca.length; i++) {
            var c = ca[i];
            while (c.charAt(0) === ' ')
                c = c.substring(1, c.length);
            if (c.indexOf(nameEQ) === 0)
                return decodeURIComponent(c.substring(nameEQ.length, c.length));
        }
        return null;
    }

    function eraseCookie(name) {
        createCookie(name, "", -1);
    }


    $(document).ready(function () {
        LoadDonVi();
        var donvi_chk = '@valueDonViChiTIet';
        var bophan_chk = '@valueBoPhan';
        var chonThang_txt = $("#MonthPicker").val();

        console.log(donvi_chk);
        console.log(bophan_chk);
        if (!donvi_chk.includes(",")) {
            if (bophan_chk != "All") {
                console.log(1);
                LoadBoPhan(parseInt(donvi_chk), parseInt(bophan_chk));
                //LoadDataTable([parseInt(donvi_chk)], bophan_chk, chonThang_txt);
            } else {
                console.log(2);
                LoadBoPhan(parseInt(donvi_chk), "All");
                //LoadDataTable([parseInt(donvi_chk)], "All", chonThang_txt);
            }
        } else {
            //LoadDataTable(donvi_chk.split(","), "All", chonThang_txt);
        }

    });
    function LoadDonVi() {
        $(function(){
            var dataGrid;
            $.ajax({
                    type: "Post",
                    url: '@Url.Action("GetDonVi", "ThongKeVungXanh")',
                    dataType: 'text',
                    success: function (data) {
                        var makeAsyncDataSource = function(dataDemo){
                            return new DevExpress.data.CustomStore({
                                loadMode: "raw",
                                key: "Id",
                                load: function() {
                                    return dataDemo;
                                }
                            });
                        };

                        $("#gridBox").dxDropDownBox({
                            value: [@valueDonViChiTIet],
                            valueExpr: "Id",
                            placeholder: "Tất cả",
                            displayExpr: "TenDonVi",
                            showClearButton: true,
                            dataSource: makeAsyncDataSource(JSON.parse(data)),
                            contentTemplate: function (e) {
                                var value = e.component.option("value"),
                                    $dataGrid = $("<div>").dxDataGrid({
                                        dataSource: e.component.getDataSource(),
                                        columns: [{
                                            dataField: "TenDonVi",
                                            caption: "Tất cả đơn vị"
                                        }],
                                        hoverStateEnabled: true,
                                        paging: { enabled: true, pageSize: 10 },
                                        filterRow: { visible: true },
                                        scrolling: { mode: "virtual" },
                                        height: 345,
                                        selection: { mode: "multiple" },
                                        selectedRowKeys: value,
                                        onSelectionChanged: function (selectedItems) {
                                            var keys = selectedItems.selectedRowKeys;
                                            e.component.option("value", keys);
                                        }
                                    });

                                dataGrid = $dataGrid.dxDataGrid("instance");

                                e.component.on("valueChanged", function (args) {
                                    var value = args.value;
                                    dataGrid.selectRows(value, false);
                                });

                                return $dataGrid;
                            },
                            onOptionChanged: function (e) {
                                if (e.name == "value") {
                                    if (e.value.length == 1) {
                                        LoadBoPhan(e.value[0],0);
                                        //LoadDataTable(e.value, "All");
                                        createCookie("DonViChiTiet", e.value);
                                        createCookie("BoPhan","All");
                                    } else {
                                         $('#BoPhan').empty();
                                         $('#BoPhan').append('<option value="All"> Tất cả</option>');
                                        //LoadDataTable(e.value, "All");
                                        if (e.value != "") {
                                            createCookie("DonViChiTiet", e.value);
                                            createCookie("BoPhan", "All");
                                        }
                                    }
                                }
                            }
                        });
                    },
                    error: function (e) {
                        swal({
                            title: "Lỗi",
                            text: "Không lấy được dữ liệu",
                            type: 'error',
                            showCancelButtonClass: 'OK'
                        });
                    }
                });


        });
    }

    function LoadBoPhan(DonViChiTiet,BoPhan) {
         //var DonViChiTiet = $('#DonViChiTiet').val();
            if (DonViChiTiet != null && DonViChiTiet != "") {
                $.ajax({
                    type: "Post",
                    url: '@Url.Action("GetAllBoPhanByDonViChiTietId2", "ThongKeVungXanh")',
                    data: { DonViChiTiet: DonViChiTiet,BoPhan:BoPhan },
                    dataType: 'text',
                    success: function (data) {
                        if (DonViChiTiet == "All") {
                            $('#BoPhan').empty();
                            $('#BoPhan').append('<option value="All"> Tất cả</option>');
                            //LoadDataTable("All", "All");
                        } else {
                            $('#BoPhan').empty();
                            $('#BoPhan').append(data);
                            //LoadDataTable(DonViChiTiet, "All");
                        }
                    },
                    error: function (e) {
                        swal({
                            title: "Lỗi",
                            text: "Không lấy được dữ liệu",
                            type: 'error',
                            showCancelButtonClass: 'OK'
                        });
                    }
                });
            } else {
                swal({
                    title: "Lỗi",
                    text: "Không lấy được dữ liệu",
                    type: 'error',
                    showCancelButtonClass: 'OK'
                });
            }
    }
    $('#BoPhan').change(function () {
        var BoPhan = $('#BoPhan').val();
        createCookie("BoPhan", BoPhan);
    });


    $('#MonthPicker').datepick({
        onShow: $.datepick.monthOnly,
        dateFormat: "yyyy-mm",
        showTrigger: '#calImg'
    });

    $('#btnXem').on("click", function () {
        var DonViChiTiet = readCookie("DonViChiTiet");
        var BoPhan = $('#BoPhan').val();
        var Thang = $("#MonthPicker").val();
        LoadDataTable(DonViChiTiet, BoPhan, Thang);
    });

    function LoadDataTable(_DonViChiTiet, _BoPhan, _Thang) {
        var _dataResponsive = {
            "DanhSachNhanVien": [
                {
                    "text": "Nguyễn Văn A",
                    "id": 1,
                    "color": "#337ab7"
                },
                {
                    "text": "Nguyễn Văn B",
                    "id": 2,
                    "color": "#337ab7"
                },
                {
                    "text": "Nguyễn Văn C",
                    "id": 3,
                    "color": "#337ab7"
                },
                {
                    "text": "Nguyễn Văn D",
                    "id": 4,
                    "color": "#337ab7"
                },
                {
                    "text": "Nguyễn Văn E",
                    "id": 5,
                    "color": "#337ab7"
                },
                {
                    "text": "Nguyễn Văn F",
                    "id": 6,
                    "color": "#337ab7"
                },
                {
                    "text": "Nguyễn Văn G",
                    "id": 7,
                    "color": "#337ab7"
                },
                {
                    "text": "Nguyễn Văn H",
                    "id": 8,
                    "color": "#337ab7"
                }
            ],
            "DanhSachNgayDiLam": [
                {
                    "NhanVienId": 1,
                    "text": "Đã đăng ký",
                    "startDate": "2021-10-01 08:00:00",
                    "endDate": "2021-10-01 17:00:00"
                },
                {
                    "NhanVienId": 1,
                    "text": "Đã đăng ký",
                    "startDate": "2021-10-02 08:00:00",
                    "endDate": "2021-10-02 17:00:00"
                },
                {
                    "NhanVienId": 1,
                    "text": "Đã đăng ký",
                    "startDate": "2021-10-03 08:00:00",
                    "endDate": "2021-10-03 17:00:00"
                },
                {
                    "NhanVienId": 2,
                    "text": "Đã đăng ký",
                    "startDate": "2021-10-01 08:00:00",
                    "endDate": "2021-10-01 17:00:00"
                },
                {
                    "NhanVienId": 2,
                    "text": "Đã đăng ký",
                    "startDate": "2021-10-03 08:00:00",
                    "endDate": "2021-10-03 17:00:00"
                },
                {
                    "NhanVienId": 2,
                    "text": "Đã đăng ký",
                    "startDate": "2021-10-05 08:00:00",
                    "endDate": "2021-10-05 17:00:00"
                },
                {
                    "NhanVienId": 2,
                    "text": "Đã đăng ký",
                    "startDate": "2021-10-07 08:00:00",
                    "endDate": "2021-10-07 17:00:00"
                },
                {
                    "NhanVienId": 3,
                    "text": "Đã đăng ký",
                    "startDate": "2021-10-01 08:00:00",
                    "endDate": "2021-10-01 17:00:00"
                },
                {
                    "NhanVienId": 3,
                    "text": "Đã đăng ký",
                    "startDate": "2021-10-04 08:00:00",
                    "endDate": "2021-10-04 17:00:00"
                },
                {
                    "NhanVienId": 3,
                    "text": "Đã đăng ký",
                    "startDate": "2021-10-10 08:00:00",
                    "endDate": "2021-10-10 17:00:00"
                },
                {
                    "NhanVienId": 1,
                    "text": "Đã đăng ký",
                    "startDate": "2021-11-01 08:00:00",
                    "endDate": "2021-11-01 17:00:00"
                },
                {
                    "NhanVienId": 1,
                    "text": "Đã đăng ký",
                    "startDate": "2021-11-02 08:00:00",
                    "endDate": "2021-11-02 17:00:00"
                },
                {
                    "NhanVienId": 1,
                    "text": "Đã đăng ký",
                    "startDate": "2021-11-03 08:00:00",
                    "endDate": "2021-11-03 17:00:00"
                }
            ]
        };
        console.log(_DonViChiTiet, _BoPhan, _Thang);
        $.ajax({
            type: "POST",
            url: '@Url.Action("GetNgayDiLamCuaNhanVien", "ThongKeVungDichTheoNgayDiLam")',
            data: { DonViChiTiet: _DonViChiTiet, BoPhan: _BoPhan, Thang: _Thang },
            dataType: 'text',
            success: function (dataResponsive) {
                var rs = JSON.parse(replaceAll(JSON.parse(dataResponsive), "'", '"'));
                console.log(rs);
                $("#gridContainer").dxScheduler({
                    timeZone: "Asia/Ho_Chi_Minh",
                    dataSource: rs.DanhSachNgayDiLam,
                    views: ["timelineMonth"],
                    currentView: "timelineMonth",
                    currentDate: _Thang,
                    editing: false,
                    groups: ["NhanVienId"],
                    height: 580,
                    resources:
                        [

                            {
                                fieldExpr: "NhanVienId",
                                allowMultiple: false,
                                dataSource: rs.DanhSachNhanVien,
                                label: "Họ tên"
                            }
                        ]
                });

            },
            error: function (e) {
                swal({
                    title: "Lỗi cập nhật",
                    text: data,
                    type: 'error',
                    showCancelButtonClass: 'OK'
                });
            }
        });
    }
    function escapeRegExp(string) {
      return string.replace(/[.*+\-?^${}()|[\]\\]/g, '\\$&'); // $& means the whole matched string
    }
    function replaceAll(str, find, replace) {
      return str.replace(new RegExp(escapeRegExp(find), 'g'), replace);
    }

   

</script>